

--  ------------  Generated from [../../../Source/CommServer/CacheDB/Upgrade/CVEntitySearch.upg] ---------- 

BEGIN

DECLARE @oldRev CHAR(20)    		
  	DECLARE @oldVal CHAR(256)			
  	DECLARE @retCode   INTEGER			
  	DECLARE @sqlError  INTEGER			
  	SET     @retCode = 0              	
  	DECLARE @sqlString nvarchar(MAX)	
  	DECLARE @macroValue nvarchar(MAX)	
      DECLARE @parentID INTEGER				
      DECLARE @tName nvarchar(128)			
      DECLARE @colID INTEGER					
      DECLARE @constId INTEGER				
      DECLARE @cName   nvarchar(128)			
  	DECLARE @oldConstraintName   nvarchar(128)	
  	DECLARE @newConstraintName   nvarchar(128)	
  	DECLARE @oldDataType         nvarchar(64)	
  	DECLARE @keyname   nvarchar(128)		
      DECLARE @dbName   nvarchar(128)			
  	DECLARE @IsNullableAttr VARCHAR(100)	
  	DECLARE @DefaultValAttr NVARCHAR(MAX)	
  	DECLARE @DataType     NVARCHAR(	256)	
  	DECLARE @ct_msg			VARCHAR(1024) = ''	
  	DECLARE @ct_tcMsg		VARCHAR(1024) = ''	
  	DECLARE @nl				VARCHAR(3) = CHAR(13) + CHAR(10)	
  	SET ROWCOUNT 0							
  	SET NOCOUNT ON

SELECT @dbName = DB_NAME()													
  SELECT @oldRev = (SELECT revision FROM GXDBVersions WHERE name = 'CVEntitySearch')	
  IF (@oldRev IS NULL)														
  BEGIN                 														
      SET @oldRev = '0.0'														
  END																			
  IF NOT EXISTS (SELECT * FROM sysobjects										
  WHERE type = 'U'															
  AND name = 'CVEntitySearch')														
  BEGIN																		
  	SET @oldRev = '0.0'														
  	DELETE FROM GXDBVersions WHERE name = 'CVEntitySearch'							
  END																			
  IF (@oldRev = '1.6')       												
  BEGIN																		
      PRINT 'RETVAL: 0   Table [' +'CVEntitySearch' +'] does NOT require upgrade.'	
  	
  END																			
  else																		
  BEGIN																		
      PRINT 'Upgrading Table [' +'CVEntitySearch' +'].'							
  END


IF NOT EXISTS (select * from sysobjects where id = object_id(N'[dbo].[CVEntitySearch]') and OBJECTPROPERTY(id, N'IsTable') = 1)
BEGIN



--  ------------  Generated from [../../../Source/CommServer/CacheDB/Tbl/CVEntitySearch.tbl] ---------- 





-- ALLOW_COMMENTS_BELOW_HERE:

-- ----------------------------------------------------------------------

--

--           Copyright (c) 1998  CommVault Systems, Inc.

--                  All rights reserved.

--

--

--        This is unpublished proprietary source code of CommVault

--        Systems, Inc. The copyright notice above does not evidence

--        any actual or intended publication of such source code.

-- ----------------------------------------------------------------------*/

-- rcsid[]="@(#)$Source: /cvs/cvsrepro/GX/vaultcx/Source/CommServer/CacheDB/Tbl/CVEntitySearch.tbl,v $ $Id: CVEntitySearch.tbl,v 1.1.2.5 2020/10/28 19:43:06 abilbrey Exp $";

print '... Creating Table: CVEntitySearch'

exec ('



DECLARE @tblRetCode integer

Set NOCOUNT ON





create table CVEntitySearch (

	user_id 		int NOT NULL,

	search_type 		int NOT NULL,

	search_id 		nvarchar(255) NOT NULL,

	search_name_id		int	NOT NULL,

	basic_attribute		xml,

	xmlText 		xml,

	created_at 		datetime NOT NULL,

	subtype_id 		int DEFAULT 0	NOT NULL,

	prefix_id               int DEFAULT NULL,

	suffix_id               int DEFAULT NULL,

	context_id              int DEFAULT NULL,

	commcell_guid 		nvarchar(40) NOT NULL



) 

set @tblRetCode = @@error

if (@tblRetCode <> 0)

BEGIN

		set @tblRetCode = @@error;

		print ''RETVAL: 10 Table [CVEntitySearch]''

END

--------





--indexes

create              index CVEntitySearch_userId_searchNameId_Idx 		on CVEntitySearch(user_id, search_name_id) include (xmlText, basic_attribute);

 

create nonclustered index CVEntitySearch_userId_createdAt_Idx 			on CVEntitySearch(user_id, created_at);



create nonclustered index CVEntitySearch_createdAt_Idx 				on CVEntitySearch(created_at);



create nonclustered index CVEntitySearch_UserId_Idx 				on CVEntitySearch(user_id);



create nonclustered index CVEntitySearch_userId_searchType_SearchNameId_idx 	on CVEntitySearch(user_id, search_type, search_name_id);





insert into GXDBVersions values(1, ''CVEntitySearch'',  ''1.1.2.5'', ''CVEntitySearch'', '''')

set @tblRetCode = @@error

if (@tblRetCode <> 0)

BEGIN

	set @tblRetCode = @@error;

	print ''RETVAL: 10 Table [GXDBVersions]''

END

ALTER TABLE CVEntitySearch ADD CONSTRAINT CVEntitySearch_user_id_search_type_search_id_subtype_id_commcell_guid_PK 		primary key (user_id, search_type, search_id, subtype_id, commcell_guid)



set @tblRetCode = @@error 

if (@tblRetCode <> 0)

BEGIN

	set @tblRetCode = @@error;

	print ''RETVAL: 02 Table [CVEntitySearch]''

END

----------

ALTER TABLE CVEntitySearch  ADD CONSTRAINT CVEntitySearch_context_id_FK	foreign key (context_id)references	 CVEntitySearchName(entityNameId)



set @tblRetCode = @@error 

if (@tblRetCode <> 0)

BEGIN

	set @tblRetCode = @@error;

	print ''RETVAL: 02 Table [CVEntitySearch]''

END

----------

ALTER TABLE CVEntitySearch  ADD CONSTRAINT CVEntitySearch_suffix_id_FK	foreign key (suffix_id)references	 CVEntitySearchName(entityNameId)



set @tblRetCode = @@error 

if (@tblRetCode <> 0)

BEGIN

	set @tblRetCode = @@error;

	print ''RETVAL: 02 Table [CVEntitySearch]''

END

----------

ALTER TABLE CVEntitySearch  ADD CONSTRAINT CVEntitySearch_prefix_id_FK	foreign key (prefix_id)references	 CVEntitySearchName(entityNameId)



set @tblRetCode = @@error 

if (@tblRetCode <> 0)

BEGIN

	set @tblRetCode = @@error;

	print ''RETVAL: 02 Table [CVEntitySearch]''

END

----------

ALTER TABLE CVEntitySearch  ADD CONSTRAINT CVEntitySearch_search_name_id_FK	foreign key (search_name_id)references	 CVEntitySearchName(entityNameId) on delete cascade



set @tblRetCode = @@error 

if (@tblRetCode <> 0)

BEGIN

	set @tblRetCode = @@error;

	print ''RETVAL: 02 Table [CVEntitySearch]''

END

----------


')
END
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'CVEntitySearch' AND COLUMN_NAME='subtype_id')			
  	BEGIN																														
  		SET @macroValue='0'			
  	IF(@macroValue <> '')			
  	BEGIN			
  		IF(ISNUMERIC(@macroValue) = 1)			
  		BEGIN			
  			SET @macroValue = @macroValue			
  		END			
  		ELSE IF(@macroValue = 'NULL')			
  		BEGIN			
  			SET @macroValue = @macroValue			
  		END			
  		ELSE IF(@macroValue LIKE '{%}')			
  		BEGIN			
  			SET @macroValue = SUBSTRING(@macroValue, 2, LEN(@macroValue) - 2)			
  		END			
  		ELSE IF(@macroValue LIKE '"%"')			
  		BEGIN			
  			SET @macroValue = '''' + REPLACE(SUBSTRING(@macroValue, 2, LEN(@macroValue) - 2), '''', '''''') + ''''			
  		END			
  		ELSE IF(@macroValue LIKE '0x%')			
  		BEGIN			
  			SET @macroValue = @macroValue			
  		END			
  		ELSE IF(@macroValue = '''')		
  		BEGIN			
  			SET @macroValue = ''''''			
  		END			
  		ELSE IF(@macroValue LIKE '%(%)%')			
  		BEGIN			
  			SET @macroValue = @macroValue			
  		END			
  		ELSE			
  		BEGIN			
  			SET @macroValue = '''' + REPLACE(@macroValue, '''', '''''') + ''''			
  		END			
  	END			
  	ELSE			
  	BEGIN			
  		SET @macroValue = ''''''			
  	END		
  		SET @sqlString = 'ALTER TABLE ' + 'CVEntitySearch'+ ' ADD ' +'subtype_id'+ ' ' +'integer'		
  			+ ' NOT NULL DEFAULT ' + @macroValue																	
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																											
  	END

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'CVEntitySearch' AND COLUMN_NAME='prefix_id')			
  	BEGIN																														
  		SET @macroValue='NULL'			
  	IF(@macroValue <> '')			
  	BEGIN			
  		IF(ISNUMERIC(@macroValue) = 1)			
  		BEGIN			
  			SET @macroValue = @macroValue			
  		END			
  		ELSE IF(@macroValue = 'NULL')			
  		BEGIN			
  			SET @macroValue = @macroValue			
  		END			
  		ELSE IF(@macroValue LIKE '{%}')			
  		BEGIN			
  			SET @macroValue = SUBSTRING(@macroValue, 2, LEN(@macroValue) - 2)			
  		END			
  		ELSE IF(@macroValue LIKE '"%"')			
  		BEGIN			
  			SET @macroValue = '''' + REPLACE(SUBSTRING(@macroValue, 2, LEN(@macroValue) - 2), '''', '''''') + ''''			
  		END			
  		ELSE IF(@macroValue LIKE '0x%')			
  		BEGIN			
  			SET @macroValue = @macroValue			
  		END			
  		ELSE IF(@macroValue = '''')		
  		BEGIN			
  			SET @macroValue = ''''''			
  		END			
  		ELSE IF(@macroValue LIKE '%(%)%')			
  		BEGIN			
  			SET @macroValue = @macroValue			
  		END			
  		ELSE			
  		BEGIN			
  			SET @macroValue = '''' + REPLACE(@macroValue, '''', '''''') + ''''			
  		END			
  	END			
  	ELSE			
  	BEGIN			
  		SET @macroValue = ''''''			
  	END		
  		SET @sqlString = 'ALTER TABLE ' + 'CVEntitySearch'+ ' ADD ' +'prefix_id'+ ' ' +'integer'		
  			+ ' NULL DEFAULT ' + @macroValue																	
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																											
  	END

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'CVEntitySearch' AND COLUMN_NAME='suffix_id')			
  	BEGIN																														
  		SET @macroValue='NULL'			
  	IF(@macroValue <> '')			
  	BEGIN			
  		IF(ISNUMERIC(@macroValue) = 1)			
  		BEGIN			
  			SET @macroValue = @macroValue			
  		END			
  		ELSE IF(@macroValue = 'NULL')			
  		BEGIN			
  			SET @macroValue = @macroValue			
  		END			
  		ELSE IF(@macroValue LIKE '{%}')			
  		BEGIN			
  			SET @macroValue = SUBSTRING(@macroValue, 2, LEN(@macroValue) - 2)			
  		END			
  		ELSE IF(@macroValue LIKE '"%"')			
  		BEGIN			
  			SET @macroValue = '''' + REPLACE(SUBSTRING(@macroValue, 2, LEN(@macroValue) - 2), '''', '''''') + ''''			
  		END			
  		ELSE IF(@macroValue LIKE '0x%')			
  		BEGIN			
  			SET @macroValue = @macroValue			
  		END			
  		ELSE IF(@macroValue = '''')		
  		BEGIN			
  			SET @macroValue = ''''''			
  		END			
  		ELSE IF(@macroValue LIKE '%(%)%')			
  		BEGIN			
  			SET @macroValue = @macroValue			
  		END			
  		ELSE			
  		BEGIN			
  			SET @macroValue = '''' + REPLACE(@macroValue, '''', '''''') + ''''			
  		END			
  	END			
  	ELSE			
  	BEGIN			
  		SET @macroValue = ''''''			
  	END		
  		SET @sqlString = 'ALTER TABLE ' + 'CVEntitySearch'+ ' ADD ' +'suffix_id'+ ' ' +'integer'		
  			+ ' NULL DEFAULT ' + @macroValue																	
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																											
  	END

IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'CVEntitySearch' AND COLUMN_NAME='context_id')			
  	BEGIN																														
  		SET @macroValue='NULL'			
  	IF(@macroValue <> '')			
  	BEGIN			
  		IF(ISNUMERIC(@macroValue) = 1)			
  		BEGIN			
  			SET @macroValue = @macroValue			
  		END			
  		ELSE IF(@macroValue = 'NULL')			
  		BEGIN			
  			SET @macroValue = @macroValue			
  		END			
  		ELSE IF(@macroValue LIKE '{%}')			
  		BEGIN			
  			SET @macroValue = SUBSTRING(@macroValue, 2, LEN(@macroValue) - 2)			
  		END			
  		ELSE IF(@macroValue LIKE '"%"')			
  		BEGIN			
  			SET @macroValue = '''' + REPLACE(SUBSTRING(@macroValue, 2, LEN(@macroValue) - 2), '''', '''''') + ''''			
  		END			
  		ELSE IF(@macroValue LIKE '0x%')			
  		BEGIN			
  			SET @macroValue = @macroValue			
  		END			
  		ELSE IF(@macroValue = '''')		
  		BEGIN			
  			SET @macroValue = ''''''			
  		END			
  		ELSE IF(@macroValue LIKE '%(%)%')			
  		BEGIN			
  			SET @macroValue = @macroValue			
  		END			
  		ELSE			
  		BEGIN			
  			SET @macroValue = '''' + REPLACE(@macroValue, '''', '''''') + ''''			
  		END			
  	END			
  	ELSE			
  	BEGIN			
  		SET @macroValue = ''''''			
  	END		
  		SET @sqlString = 'ALTER TABLE ' + 'CVEntitySearch'+ ' ADD ' +'context_id'+ ' ' +'integer'		
  			+ ' NULL DEFAULT ' + @macroValue																	
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																											
  	END

SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'CVEntitySearch' AND xType = 'U')								
  	IF NOT EXISTS (SELECT  name FROM sys.foreign_keys WHERE parent_object_id = @parentID AND name = 'CVEntitySearch_prefix_id_FK')	
  	BEGIN																								
  		SET @sqlString = 'ALTER TABLE [' + 'CVEntitySearch' +']' + 'ADD CONSTRAINT [' + 'CVEntitySearch_prefix_id_FK' +'] FOREIGN KEY (' + 'prefix_id' + ') REFERENCES ['+ 'CVEntitySearchName' +'] (' + 'entityNameId' + ')'		
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																					
  	END

SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'CVEntitySearch' AND xType = 'U')								
  	IF NOT EXISTS (SELECT  name FROM sys.foreign_keys WHERE parent_object_id = @parentID AND name = 'CVEntitySearch_suffix_id_FK')	
  	BEGIN																								
  		SET @sqlString = 'ALTER TABLE [' + 'CVEntitySearch' +']' + 'ADD CONSTRAINT [' + 'CVEntitySearch_suffix_id_FK' +'] FOREIGN KEY (' + 'suffix_id' + ') REFERENCES ['+ 'CVEntitySearchName' +'] (' + 'entityNameId' + ')'		
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																					
  	END

SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'CVEntitySearch' AND xType = 'U')								
  	IF NOT EXISTS (SELECT  name FROM sys.foreign_keys WHERE parent_object_id = @parentID AND name = 'CVEntitySearch_context_id_FK')	
  	BEGIN																								
  		SET @sqlString = 'ALTER TABLE [' + 'CVEntitySearch' +']' + 'ADD CONSTRAINT [' + 'CVEntitySearch_context_id_FK' +'] FOREIGN KEY (' + 'context_id' + ') REFERENCES ['+ 'CVEntitySearchName' +'] (' + 'entityNameId' + ')'		
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																					
  	END

--if there does not exists commcell_guid field at all, then create commcellguid as nvarchar
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'CVEntitySearch' AND COLUMN_NAME='commcell_guid')

BEGIN

--add column commcell_guid to CVEntitySearch
IF (' ALTER TABLE CVEntitySearch ADD commcell_guid nvarchar(40) DEFAULT NULL ' <> '')							
  		SET @sqlString = ' ALTER TABLE CVEntitySearch ADD commcell_guid nvarchar(40) DEFAULT NULL '				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END

--update column commcell_guid
IF (' UPDATE CVEntitySearch SET commcell_guid = (select  csGUID from [CommServ].[dbo].[APP_CommCell] where id = 2) where commcell_guid IS NULL' <> '')							
  		SET @sqlString = ' UPDATE CVEntitySearch SET commcell_guid = (select  csGUID from [CommServ].[dbo].[APP_CommCell] where id = 2) where commcell_guid IS NULL'				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END

--update column commcell_guid to NON NULL
IF (' ALTER TABLE CVEntitySearch ALTER COLUMN commcell_guid  nvarchar(40) NOT NULL ' <> '')							
  		SET @sqlString = ' ALTER TABLE CVEntitySearch ALTER COLUMN commcell_guid  nvarchar(40) NOT NULL '				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END

END

--if there exists commcell_guid which is of datatype UNIQUEIDENTIFIER
ELSE IF EXISTS(SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'CVEntitySearch' AND COLUMN_NAME='commcell_guid' AND DATA_TYPE = 'UNIQUEIDENTIFIER')

BEGIN

--we need not worry about the data since these are cacheDB tables which will be repopulated
--1. delete data from tables
--2. drop primary key constraint
--3. drop column
--4. add column with correct datatype
--5. add primary key with column with correct datatype
--1. delete data from tables
	DELETE FROM CVEntitySearch

	DELETE FROM UserCVEntitySearch

	DELETE FROM CVEntitySearchNameTrigram

	DELETE FROM CVEntitySearchName

--2. drop PK
EXECUTE @retCode = cvsp_drop_pk 'CVEntitySearch'

--3. drop column
IF EXISTS(SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME='CVEntitySearch' AND COLUMN_NAME='commcell_guid')			
  	BEGIN																							
  	SELECT @parentID = (SELECT id FROM sysobjects WHERE name='CVEntitySearch' AND xType = 'U')				
  		SELECT @colID    = (SELECT colid FROM syscolumns WHERE id = @parentID AND NAME='commcell_guid')			
  		SELECT @constId  = (SELECT a.constid FROM sysconstraints a, sysobjects b							
  					WHERE a.id = @parentID AND a.colid = @colid and a.constid = b.id and b.xtype = 'D')		
  		IF (@constId IS NOT NULL)																			
  		BEGIN																								
  			  SELECT @cName    = (SELECT name FROM sysobjects WHERE id=@constId)							
  			  SET  @sqlString= 'ALTER TABLE ' +'CVEntitySearch' + ' DROP CONSTRAINT [' + @cName + ']'		
  			  IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																				
  		END 
  		SET @sqlString= 'ALTER TABLE ' +'CVEntitySearch'+ ' DROP COLUMN ' +'commcell_guid'	
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																				
  	END

--4. add column with correct datatype
IF NOT EXISTS (SELECT * FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME = 'CVEntitySearch' AND COLUMN_NAME='commcell_guid')			
  	BEGIN																													
  		SET @sqlString = 'ALTER TABLE ' + 'CVEntitySearch'+ '  ADD ' +'commcell_guid'+ '  ' +'nvarchar(40)'			
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																			
  		SET @macroValue=''''			
  	IF(@macroValue <> '')			
  	BEGIN			
  		IF(ISNUMERIC(@macroValue) = 1)			
  		BEGIN			
  			SET @macroValue = @macroValue			
  		END			
  		ELSE IF(@macroValue = 'NULL')			
  		BEGIN			
  			SET @macroValue = @macroValue			
  		END			
  		ELSE IF(@macroValue LIKE '{%}')			
  		BEGIN			
  			SET @macroValue = SUBSTRING(@macroValue, 2, LEN(@macroValue) - 2)			
  		END			
  		ELSE IF(@macroValue LIKE '"%"')			
  		BEGIN			
  			SET @macroValue = '''' + REPLACE(SUBSTRING(@macroValue, 2, LEN(@macroValue) - 2), '''', '''''') + ''''			
  		END			
  		ELSE IF(@macroValue LIKE '0x%')			
  		BEGIN			
  			SET @macroValue = @macroValue			
  		END			
  		ELSE IF(@macroValue = '''')		
  		BEGIN			
  			SET @macroValue = ''''''			
  		END			
  		ELSE IF(@macroValue LIKE '%(%)%')			
  		BEGIN			
  			SET @macroValue = @macroValue			
  		END			
  		ELSE			
  		BEGIN			
  			SET @macroValue = '''' + REPLACE(@macroValue, '''', '''''') + ''''			
  		END			
  	END			
  	ELSE			
  	BEGIN			
  		SET @macroValue = ''''''			
  	END		
  		SET @sqlString = 'UPDATE ' + 'CVEntitySearch'+ '  SET ' +'commcell_guid' + '  = ' + @macroValue		
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																			
  		SET @sqlString = 'ALTER TABLE ' + 'CVEntitySearch'+ '  ALTER COLUMN ' +'commcell_guid'+ '  ' +'nvarchar(40)' + '  NOT NULL'					
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																			
  	END

--5 is outside if clause
END

SELECT @parentID = (SELECT id FROM sysobjects WHERE name = 'CVEntitySearch' AND xType = 'U')								
  	SELECT @keyname = (SELECT  name FROM sysobjects WHERE parent_obj = @parentID AND xtype = 'PK')		
  	IF (@keyname IS NULL OR @keyname != 'CVEntitySearch_user_id_search_type_search_id_subtype_id_commcell_guid_PK')														
  	BEGIN																								
  		IF (@keyname IS NOT NULL)																		
  		BEGIN																							
  			EXECUTE @retCode = cvsp_drop_pk 'CVEntitySearch'													
  		END																								
  		SET @sqlString = 'ALTER TABLE [' + 'CVEntitySearch' +']' + 'ADD CONSTRAINT [' + 'CVEntitySearch_user_id_search_type_search_id_subtype_id_commcell_guid_PK' +'] PRIMARY KEY (' + 'user_id, search_type, search_id, subtype_id, commcell_guid' + ')'		
  		IF ('' <> '')							
  		SET @sqlString = ''				
  	SET @retCode = 0						
  	EXEC sp_executesql @sqlString			
  	SET @sqlError = @@error					
  	IF (@sqlError <> 0)						
  	BEGIN									
  		IF (99 > @retCode)				
  	  		SET @retCode = 99			
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), 99) + ' [' + @sqlString + ']' + ' SQL Error: ' + CONVERT(CHAR(8), @sqlError)		+ ' [' + @sqlString + ']'						
  		IF (@retCode > 10)					
  			RETURN							
  	END																					
  	END

IF (@retCode < 10)													
  	BEGIN																
  		IF NOT EXISTS (SELECT * FROM GXDBVersions WHERE name = 'CVEntitySearch')			
  			insert into GXDBVersions VALUES(1, 'CVEntitySearch', '0.0', 'CVEntitySearch', '')	
  			UPDATE GXDBVersions SET revision = '1.6' WHERE name = 'CVEntitySearch'		
   PRINT 'RETVAL: ' + CONVERT(CHAR(3), @retCode) + 'Table [' + 'CVEntitySearch' + '] upgraded successfully to '			+ ' revision [' + '1.6' + '].'										
  	END																	
  	else																
  		PRINT 'RETVAL: ' + CONVERT(CHAR(5), @retCode) + ' TABLE ' + 'CVEntitySearch' + ' Upgrade Completed with Errors.'  
  	RETURN			   -- No more upgrade for this TABLE!

END

GO
IF @@error <> 0 RETURN
GO
